# __gnu_cxx::recursive_init_error Class Reference
[Exceptions]

Exception thrown by __cxa_guard_acquire.6.7[stmt.dcl]/4: If control re-enters the declaration (recursively) while the object is being initialized, the behavior is undefined. More...

Inheritance diagram for __gnu_cxx::recursive_init_error:
[legend]

List of all members.

## Public Member Functions

- virtual const char * what () const throw ()

## Detailed Description

Exception thrown by __cxa_guard_acquire.

6.7[stmt.dcl]/4: If control re-enters the declaration (recursively) while the object is being initialized, the behavior is undefined.

Since we already have a library function to handle locking, we might as well check for this situation and throw an exception. We use the second byte of the guard variable to remember that we're in the middle of an initialization.

Definition at line 620 of file cxxabi.h.

## Member Function Documentation

virtual const char* std::exception::what | ( |  | ) | const throw ()`[virtual, inherited]`

Returns a C-style character string describing the general cause of the current error.

Reimplemented in std::bad_exception, std::bad_alloc, std::bad_cast, std::bad_typeid, std::future_error, std::logic_error, std::runtime_error, std::tr1::bad_weak_ptr, and std::ios_base::failure.

The documentation for this class was generated from the following file:

- cxxabi.h